#ifndef CONSENSUSMANAGER_HH
#define CONSENSUSMANAGER_HH 1

#include "RequestManager.hh"
#include "Foundation.hh"

using libSlice::SliceData;
using libSlice::ConsensusData;

class ConsensusManager : public RequestManager
{
public:
  ConsensusManager();
  ~ConsensusManager();

  void addSlice(SliceData * slice);

  int  printResults();

  // Option Handlers
  static void setDoConsensusQC(const string & value);
  static void setDoConsensusQV(const string & value);
  static void setDoEditflag(const string & value);
  static void setMaxPercDiscrepancy(const string & value);

  static void handleOptions(Foundation * tf);

  static int getDefaultAmbiguityMode();

private:
  string m_resultsConsensus;
  string m_resultsQualityClass;
  string m_resultsQualityValue;
  string m_resultsEditflag;

  bool   m_includeSpace;

  static int m_doConsensusQC;
  static int m_doConsensusQV;
  static int m_doEditflag;
  static int m_defaultAmbiguityMode;

  static int m_maxPercDiscrepancy;

  bool calculateEditflag(SliceData * slice, int qc, char cons);
};

#endif
