#ifndef SliceAugmenter_HH 
#define SliceAugmenter_HH 1

#include "RequestManager.hh"
#include "TrimmedSequence.hh"

#include <map>
#include <vector>

using libSlice::SliceData;

typedef map<string, TrimmedSequence *> SeqMap;
typedef map<string, ReadData *> ReadMap;
typedef vector<ReadData *> ReadList;
typedef map<string, long long> OffsetMap;

class SliceAugmenter : public RequestManager
{
public:
  SliceAugmenter();
  ~SliceAugmenter();

  void addSlice(SliceData * slice);
  void addSliceRange(long & index, long & gindex);
  void addRequest(ConsensusRequest * request);
  void addReadData(ReadData * readData);

  int  printResults();
  void setPrefix(const string & prefix);

private:
  void parseFile(ifstream & file, bool isQual);
  void loadIndex(ifstream & file, bool isQual);
  void processPrefix();
  void setAugmentedData(ReadData * readData, TrimmedSequence * sequence);
  TrimmedSequence * handleBuffer(char * buffer, TrimmedSequence * cs, bool isQual);

  SeqMap m_seqMap;
  ReadMap m_readMap;
  ReadList m_readList;
  string m_prefix;

  OffsetMap m_qualidx;
  OffsetMap m_seqidx;
};

#endif
