#include "AmbiguityWriter.hh"

AmbiguityWriter::AmbiguityWriter() : RequestManager("AmbiguityWriter")
{
}

AmbiguityWriter::~AmbiguityWriter()
{

}

void AmbiguityWriter::addSliceRange(long & index, long & gindex)
{

}

void AmbiguityWriter::addSlice(SliceData * slice)
{
  slice->setHighQualityThreshold(m_highQualityThreshold);
  slice->setScoringModel(m_scoringModel);

  slice->setDoAmbiguity(0);
  slice->doCalculations();
  char ptw = slice->getConsensus();

  slice->setDoAmbiguity(1);
  slice->doCalculations();
  char cw = slice->getConsensus();

  slice->setDoAmbiguity(2);
  slice->doCalculations();
  char hq = slice->getConsensus();

  slice->setDoAmbiguity(3);
  slice->doCalculations();
  char conic = slice->getConsensus();

  cout << slice->getGindex() << " " 
       << ptw << " "
       << cw << " "
       << conic << " "
       << hq << " : ";

  for (int i = 0; i < slice->getDepth(); i++)
  {
    cout << slice->getBase(i);
  }

  cout << " ";

  for (int i = 0; i < slice->getDepth(); i++)
  {
    if (i) { cout << ":"; }
    cout << (int)slice->getQualVal(i);
  }

  cout << endl;

  delete slice;
}


int AmbiguityWriter::printResults()
{
  return m_errorCount;
}


void AmbiguityWriter::handleOptions(Foundation * tf)
{
  RequestManager::handleOptions(tf);
}
